<template>
  <CommandExecuteContext v-bind:commands="commandContext"></CommandExecuteContext>
</template>


<script>
  import UserCommands from "../../../commands/UserCommands"
  import CommandExecuteContext from '../../../commands/CommandExecuteContext'
  import ElineTemplateService from '@/domain/services/Business/ElineTemplateService.js'
  import HelperUtil from "../../../utils/HelperUtil";

  export default {
    props:['command'],

    components: {
      CommandExecuteContext,
    },

    data: function () {   //存放数据
      return {
        deleteList: this.command.target,

        //命令
        commandContext: {},

        confirmFlag: {
          confirm: false,
        },
      }
    },
    methods: {
      open() {
        let _this = this;
        _this.InfoTip.conformTip(_this, HelperUtil.getCheckStatusCodeObjectByCode(_this.successCode.DELETE_CONFIRM)).then(() => {
          this.deleteDevice();
        }).catch(()=>{
          this.command.done()
        });
      },

      //删除设备
      deleteDevice() {
        let _this = this;
        let loadingInstance = _this.Loading.openLoading();
        ElineTemplateService.deleteElineTemplates(this.deleteList).then(result => {
          _this.Loading.closeLoading(loadingInstance);
          _this.InfoTip.successTip(_this,HelperUtil.getStatusCodeObjectByCode(_this.successCode.DELETE_CODE));
          this.command.done()
        }).catch(err => {
          //失败
          _this.Loading.closeLoading(loadingInstance);
          _this.InfoTip.errorTip(_this, err);
          this.command.done()
        });
      },
    },

    watch: {
      commandContext (newVal, oldVal){
        let _this = this;
        if(_this.confirmFlag.confirm){
          this.open();
          this.confirmFlag.confirm = false
        }
        else{
          if(JSON.stringify(newVal) === '{}'){
            _this.close()
          }
        }
        deep: true
      },
    },

    created() {
      this.confirmUserCommand.execute();
    },

    computed: {
      confirmUserCommand(){
        this.confirmFlag.confirm = false;
        return UserCommands.confirmUserCommand(this.commandContext, this.confirmFlag)
      },
    },

  }
</script>
